/* -------------------------------------------------------------
 * Copyright 2003-2010 Netlogic Microsystems Inc. (“Netlogic”).
 * -------------------------------------------------------------
 * This is a derived work from software originally provided by  
 * the external entity identified below. The licensing terms and  
 * warranties specified in the header of the original work apply 
 * to this derived work.
 * --------------------------#NETL_1#---------------------------
 */
/*
 * (C) Copyright 2003
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * This file contains the configuration 
 * parameters for the NETL8XX board.
 */

#ifndef __CONFIG_NETL8XX_H
#define __CONFIG_NETL8XX_H

#define CONFIG_MIPS			1	/* MIPS 5Kc CPU core	*/
#define CONFIG_NETL8XX		1	/* on a NETL8XX Board	*/

#define	STAGE2_LOADADDR		0x8C100000

#define CONFIG_SYS_NS16550_REG_SIZE   	(-4)

/* XLP A0 has the refclk set to 133.0MHz instead of 133.333333MHz */
#define CFG_NS16550_CLK          		133000000

#define CONFIG_CONS_INDEX   			1
#define CONFIG_BAUDRATE					115200
#define CFG_NS16550_COM1    			0xB8030100	/* UART 0 */
#define CFG_PBSIZE               		256

#define CONFIG_STACKSIZE				(128 * 1024)

/* SPI NOR+NAND Flash Defines
 */
#define CONFIG_SPI_REFCLK             	133333334
#define CONFIG_SPI_DEFAULT_SPEED      	(CONFIG_SPI_REFCLK/8)
#define CONFIG_SPI_DEFAULT_MODE       	0
#define CONFIG_SNOR_DEFAULT_SPEED  		1000000
#define CONFIG_SNOR_DEFAULT_MODE   		SPI_MODE_3

/* valid baudrates */
#define CONFIG_SYS_BAUDRATE_TABLE		{ 9600, 19200, 38400, 57600, 115200 }

#define	CONFIG_TIMESTAMP		/* Print image info with timestamp */

#undef	CONFIG_BOOTARGS
#define CONFIG_BOOTCOMMAND				"run flash_self"

/*
 * BOOTP options
 */
#define CONFIG_BOOTP_BOOTFILESIZE
#define CONFIG_BOOTP_BOOTPATH
#define CONFIG_BOOTP_GATEWAY
#define CONFIG_BOOTP_HOSTNAME

#define CONFIG_SYS_SDRAM_BASE		0x80000000
#define CONFIG_SYS_INIT_SP_OFFSET      0x400000
#define CONFIG_SYS_MALLOC_LEN		128*1024
#define CONFIG_SYS_BOOTPARAMS_LEN	128*1024

#define CONFIG_SYS_I2C_MUX 1

/*
 * Miscellaneous configurable options
 */
#define	CONFIG_SYS_LONGHELP						/* undef to save memory      */
#define	CONFIG_SYS_PROMPT		"Netl8xx# "		/* Monitor Command Prompt    */
#define	CONFIG_SYS_CBSIZE		256				/* Console I/O Buffer Size   */
#define	CONFIG_SYS_PBSIZE 		(CONFIG_SYS_CBSIZE+sizeof(CONFIG_SYS_PROMPT)+16)  /* Print Buffer Size */
#define CONFIG_SYS_HZ			1000
#define	CONFIG_SYS_MAXARGS		16				/* max number of command args*/

#define	CONFIG_SYS_LOAD_ADDR		0x80500000	/* default load address	*/

#define CONFIG_SYS_MEMTEST_START	0x80000000
#define CONFIG_SYS_MEMTEST_END		0x90000000

#define CONFIG_PLB2800_ETHER
#define CONFIG_NET_MULTI

#define	CONFIG_MISC_INIT_R

/*-----------------------------------------------------------------------
 * FLASH and environment organization
 */
#define CONFIG_SYS_MAX_FLASH_BANKS	1	/* max number of memory banks */
#define CONFIG_SYS_MAX_FLASH_SECT	(35)	/* max number of sectors on one chip */

#define PHYS_FLASH_1		0xb0000000 /* Flash Bank #1 */

/* The following #defines are needed to get flash environment right */
#define	CONFIG_SYS_MONITOR_BASE	TEXT_BASE
#define	CONFIG_SYS_MONITOR_LEN		(192 << 10)

#define CONFIG_SYS_FLASH_BASE		PHYS_FLASH_1

/* timeout values are in ticks */
#define CONFIG_SYS_FLASH_ERASE_TOUT	(6 * CONFIG_SYS_HZ) /* Timeout for Flash Erase */
#define CONFIG_SYS_FLASH_WRITE_TOUT	(6 * CONFIG_SYS_HZ) /* Timeout for Flash Write */

#define	CONFIG_ENV_IS_IN_FLASH	1

/* Address and size of Primary Environment Sector	*/
#define CONFIG_ENV_ADDR		0xB0008000
#define CONFIG_ENV_SIZE		0x4000

#define CONFIG_FLASH_32BIT
#define CONFIG_NR_DRAM_BANKS	1

/*-----------------------------------------------------------------------
 * Cache Configuration
 */
#define CONFIG_SYS_DCACHE_SIZE		16384
#define CONFIG_SYS_ICACHE_SIZE		16384
#define CONFIG_SYS_CACHELINE_SIZE	32

/*
 * Temporary buffer for serial data until the real serial driver
 * is initialised (memtest will destroy this buffer)
 */
#define CONFIG_SYS_SCONSOLE_ADDR     (CONFIG_SYS_SDRAM_BASE + CONFIG_SYS_INIT_SP_OFFSET - \
			       CONFIG_SYS_DCACHE_SIZE / 2)
#define CONFIG_SYS_SCONSOLE_SIZE     (CONFIG_SYS_DCACHE_SIZE / 4)

#endif	/* __CONFIG_NETL8XX_H */
