/*
 * Copyright 2003-2010 Netlogic Microsystems (Netlogic). All rights
 * reserved. Redistribution and use in source and binary forms, with 
 * or without modification, are permitted provided that the following 
 * conditions are met:
 *
 *	1. 	Redistributions of source code must retain the above copyright
 *		notice, this list of conditions and the following disclaimer.
 *
 *	2. 	Redistributions in binary form must reproduce the above copyright
 *		notice, this list of conditions and the following disclaimer in
 *		the documentation and/or other materials provided with the
 *		distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 * --------------------------------#NETL_2#--------------------------------
 */
#include <config.h>
#include <asm/asm.h>
#include <asm/regdef.h>
#include <asm/mipsregs.h>
#include <asm/arch/cpu.h>

LEAF(lowlevel_init)

	/* Program Bridge BAR Registers for
	 * letting DRAM Accesses through.
	 */
	li      t0, CPU_MMIO_OFFSET(0,BRIDGE)

	/* First, disable all Bars */
	sw      zero, (NBU_DRAM_BAR_LIMIT_0 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_1 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_2 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_3 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_4 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_5 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_6 << 2)(t0)
	sw      zero, (NBU_DRAM_BAR_LIMIT_7 << 2)(t0)

	/* 0M -> 256M Node 0 */

	li      t1, 0x00							/* Base */
	sw      t1, (NBU_DRAM_BAR_0 << 2)(t0)
	li      t1, (0xff<<12)						/* Limit */
	sw      t1, (NBU_DRAM_BAR_LIMIT_0 << 2)(t0)
	
	/* 512M -> (1G+256M) Node 0 */
	
	li      t1, (0x00200<<12)							
	sw      t1, (NBU_DRAM_BAR_1 << 2)(t0)
	li      t1, (0x4ff<<12)						
	sw      t1, (NBU_DRAM_BAR_LIMIT_1 << 2)(t0)

	/* Additionally, program the DRAM BAR
	 * Translation registers to account for
	 * holes in the DRAM memory map
	 */
	li      t1, (0x00100<<12)
	or		t1, t1, 0x01
	sw      t1, (NBU_DRAM_BAR_XLAT_1 << 2)(t0)

	jr      ra
	nop

END(lowlevel_init)
